<?php

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CRM\Service\ProfileService;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\Environment;

class ProfileController extends TeknisaCrud
{
    protected $profileService;
    protected $environment;
    
    public function __construct(ProfileService $profileService, Environment $environment){
        $this->profileService = $profileService;
        $this->environment    = $environment;
    }
    
    public function redefinirSenha(DTO\Request $request, DTO\Response $response){
        try{
            $row = $request->getRow()[0];
            $cdoperador = $this->environment->getCdOperador(); 
            $paramsCdOperador = 
                array(
                    "CDOPERADOR" => $cdoperador    
                );
            $actualPassword = $this->profileService->getPasswordOperator($paramsCdOperador)['CDSENHAOPERWEB'];
            if($actualPassword != md5($row['SENHA_ATUAL'])){
                $response->setError(new Response\Error('Senha atual incorreta', 10));
            }else{
                $novaSenha      = md5($row['NOVA_SENHA']);
                $confirmarSenha = md5($row['CONFIRMAR_SENHA']);
                if($novaSenha != $confirmarSenha){
                    $response->setError(new Response\Error('Senhas não coincidem', 20));    
                }
                $paramsUpdate =  
                    array('CDSENHAOPERWEB' => $novaSenha,
                          'CDOPERADOR'     => $cdoperador,
                          'NRORG'          => $this->environment->getNrOrg()
                    );
                $this->profileService->setNewPassword($paramsUpdate);
                $response->addDataSet(new DataSet("DADOS", array("CDSENHAOPERWEB" => $novaSenha)));
            }
        
            
        }catch(\Exception $e)
            {
                $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
            }
    }
    
}