<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\SMTP;

class crm00050002ReservaProspectController extends TeknisaCrud
{
    protected $dataSourceName = 'prospect_prosprevenda_reservaprosp';

    protected $reservaProspectService;
    protected $smtpService;
    
    public function __construct($crudService, $parameterBag, $reservaProspectService, $smtpService){
        
        $this->reservaProspectService       = $reservaProspectService;
        $this->smtpService                  = $smtpService;
        
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function insertResaleProspect(Row $row){
        
        $row = $row->getRow();
        
        $this->reservaProspectService->callForInsertResaleProspect($row);
        
    }
    
    public function selectOperatorResaleNumber(Row $row, Response $response){
        
        $row = $row->getRow();
        
        $resaleNumber = $this->reservaProspectService->callForSelectOperatorResaleNumber($row);
        
        $response->addDataSet(new DataSet('DADOS', $resaleNumber));
    }
    
    public function sendEmail(Row $row){
        
        $this->smtpService->setFrom("arthur.tondato@teknisa.com");
        $this->smtpService->setFromName("arthur.tondato@teknisa.com");
        $this->smtpService->setSubject("Importante");
        $this->smtpService->sendMail("<table border='1px'><tr><td>campo1</td><td>campo2</td></tr></table>", array("victor.oliveira@teknisa.com"));
        
    }

}
?>