<?php
namespace Teknisa\CRM\Service;

use Teknisa\Model\Util\NovoCodigo;

class OrgOperService {
    
    protected $newCode;
    protected $orgOperFactory;
    protected $environment;
    
    public function __construct ($orgOperFactory, $newCode, $environment) {
        
        $this->orgOperFactory    = $orgOperFactory;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
    }
    
    public function searchForNewCode($nrorg) {
        
        $novoCodigo = $this->orgOperFactory->searchForNewCode($nrorg);
        
        if(empty($novoCodigo)) {
            return 1;
        } else if($novoCodigo == $nrorg - 1) {
            return $nrorg + 1;
        } else {
            return $novoCodigo;
        }
        
    }
    
    public function verifyMainOrg($nrorg) {
        $this->orgOperFactory->verifyMainOrg($nrorg);
    }
    
    public function deleteOperators($rows) {
        try {
            $error = '';
            if(isset($rows[0])) {
                foreach($rows as $row){
                    $params = array(
                        "P_NRORG"         => $row['NRORG'],
                        "P_CRM_NRORGTRAB" => $row['CRM_NRORGTRAB'],
                        "P_CDOPERADOR"    => $row['CDOPERADOR'],
                        "P_IDATIVO"       => $row['IDATIVO']
                    );
                    
                    $params2 = array(
                        "P_NRORG"         => $row['NRORG'],
                        "P_CRM_NRORGTRAB" => $row['CRM_NRORGTRAB'],
                        "P_NRPARCNEGOCIO" => $row['NRPARCNEGOCIO']
                    );
                    
                    $retorno = $this->orgOperFactory->deleteOperator($params, $this->orgOperFactory->verifyOrgTrab($params), $row['NMOPERADOR'], $this->environment->getCdoperador(), $params2);
                    if(!empty($retorno)) {
                        if(empty($error)) {
                            $error .= $row['NMOPERADOR'];
                        } else {
                            $error = $error . ', ' . $row['NMOPERADOR'];
                        }
                    }
                }
            } else {
                $params = array(
                    "P_NRORG"         => $rows['NRORG'],
                    "P_CRM_NRORGTRAB" => $rows['CRM_NRORGTRAB'],
                    "P_CDOPERADOR"    => $rows['CDOPERADOR'],
                    "P_IDATIVO"       => $rows['IDATIVO']
                );
                
                $params2 = array(
                    "P_NRORG"         => $row['NRORG'],
                    "P_CRM_NRORGTRAB" => $rows['CRM_NRORGTRAB'],
                    "P_NRPARCNEGOCIO" => $rows['NRPARCNEGOCIO']
                );
                
                $retorno = $this->orgOperFactory->deleteOperator($params, $this->orgOperFactory->verifyOrgTrab($params), $rows['NMOPERADOR'], $this->environment->getCdoperador(), $params2);
                if(!empty($retorno)) {
                     $error = $error . $rows['NMOPERADOR'];
                }
                
            }
            return $error;
            
        } catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function verifyExistenceOfOperators($row) {
        $params = array(
            "P_NRORG" => $row['NRORG'],
            "P_CRM_NRORGTRAB" => $row['CRM_NRORGTRAB']
        );
        $existe = $this->orgOperFactory->verifyExistenceOfOperators($params);
        
        if(empty($existe)) {
            return false;
        } else {
            return true;
        }
    }
    
    public function alterarNrOrgTrab($cdoperador, $nrorg, $crm_nrorgtrab) {
        $params = array(
            "P_CDOPERADOR"     => $cdoperador,
            "P_NRORG"          => $nrorg,
            "P_CRM_NRORGTRAB"  => $crm_nrorgtrab
        );
        
        $this->orgOperFactory->alterarNrOrgTrab($params);
    }
    
    public function setOperStatus($cdoperador, $nrparcnegocio, $nrorg, $crm_nrorgtrab, $operInclusao) {
        $params = array(
            "P_NRPARCNEGOCIO"    => $nrparcnegocio,
            "P_NRORG"            => $nrorg,
            "P_CRM_NRORGTRAB"    => $crm_nrorgtrab,
            "P_CDOPERINCLUSAO"   => $operInclusao
        );
        
        $this->orgOperFactory->setOperStatus($params);
    }
    
}
?>