function crm20000_Caso_Controller(ScreenService, templateManager, Utilities, restEngine, fileRepository, localStorageEngine, Operador_Repository, General, CRM_Utilities, ZHPromise, Messages, ZhFilterPreferences) {
	var self = this;
    
    this.widgetOnEnterOnce = function(widget) {
            
            var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
            
            var field = widget.getField('CDOPERCONT');
            Utilities.insertFilterWithoutReload(field, "NRORG", "=", loggedOperatorInfos.NRORG, 0);
            field.reload();
            
            field.filterProperties.defaultValue = [loggedOperatorInfos.CDOPERADOR];
            field.defaultValue = loggedOperatorInfos.CDOPERADOR;
            
            Utilities.insertFilterWithoutReload(widget, "P_NRORG", "=", loggedOperatorInfos.NRORG, 0);
            Utilities.insertFilterWithoutReload(widget, "CDOPERCONT", "=", loggedOperatorInfos.CDOPERADOR, 1);
            
            Utilities.insertFilter(widget.getField('NMSISTEMA'), "CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 0);
            Utilities.insertFilter(widget.getField('NMSISTEMA'), "NRORG", "=", loggedOperatorInfos.NRORG, 1);
            Utilities.insertFilter(widget.getField('CDSISTEMA'), "CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 0);
            Utilities.insertFilter(widget.getField('CDMOTICONT'), "CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 1);
            //widget.reload();
            ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.iniciaFiltrosWidevolucao = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            var field = widget.getField('NMMOTIEVOCON');
            Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(field, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
            
            field = widget.getField('NMSEQRESULEVOL');
            Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(field, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidCONCLUSAO = function(widget)
    {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        Utilities.insertFilterWithoutReload(widget, "NRORG", "=", 1, 0);
        Utilities.insertFilterWithoutReload(widget, "NRSEQCONTATO", "=", widget.parent.parent.currentRow.NRSEQCONTATO, 1);
        
        var field = widget.getField('NMSEQRESULEVOL');
        Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", loggedOperatorInfos.NRORG, 0);
        Utilities.insertFilter(field, "P_CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 1);
    };

    self.iniciaFiltrosWidposvenda = function(widget)
    {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var field = widget.getField('NMOPERADOR');
        Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", loggedOperatorInfos.NRORG, 0);
        Utilities.insertFilter(field, "P_NRPARCNEGOCIO", "=", loggedOperatorInfos.NRPARCNEGOCIO, 1);
        
        field = widget.getField('NMPRINCIPALPARC');
        Utilities.insertFilter(field, "NRPARCNEGOCIO", "=", loggedOperatorInfos.NRPARCNEGOCIO, 0);
    };
    
    self.initFilterMotivo = function(fieldNMMOTIVO)
	{
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
    		if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            var objectFilter = 
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": operator[0].CDOPERADOR
                };
                
            fieldNMMOTIVO.dataSourceFilter.push(objectFilter);
            fieldNMMOTIVO.reload();

        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
	};
    
	self.casoNewRow = function(widget)
	{
        
        General.widgetNewRow(widget);
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        widget.getField('EMAIL').readOnly = true;
        widget.getField('TELEFONE').readOnly = true;
        widget.getField('NMCLASSIFICACAOCASO').readOnly = true;
        widget.getField('NMOPERCONT').readOnly = true;
        
        currentRow.CDFILIAL = "";
        currentRow.NMOPERCONT = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERCONT = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRSEQSITUACAO = 1;
        currentRow.NRPARCINTERLOCUTOR = null;
        currentRow.NRCLASSIFICACAOCASO = null;
        currentRow.IDGERAFATURA = 'NAO';
        currentRow.IDTPCONTATO = 'C';
        currentRow.IDSTATUSCONT = 'A';
        currentRow.NMGERAFATURA = 'Considera';
        currentRow.DTHRCONTATO = moment(new Date()).format('DD/MM/YYYY HH:mm');
        
        restEngine.post('crm#/getSituacao', {'requestType':'Row', 'row': widget.currentRow},
        undefined, undefined, undefined).then(function(response)
        {
            currentRow.NMSEQSITUACAO = response.dataset.DADOS.NMSITUACAO;
        });
	};

    self.casoEdit = function(widget)
    {
        widget.getField('NMCLASSIFICACAOCASO').readOnly = false;
        widget.getField('NMOPERCONT').readOnly = false;

        General.widgetEdit(widget);
    };


    self.casoCancel = function(widget)
    {
        widget.getField('NMCLASSIFICACAOCASO').readOnly = true;
        widget.getField('NMOPERCONT').readOnly = true;

        General.widgetCancelForm(widget);
    };
    
	self.conclusaoNewRow = function(widget)
	{

		General.widgetNewRow(widget);
		self.defaultEditAuditRow(widget);
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        widget.currentRow.NMOPERCONCLUSAO = loggedOperatorInfos.NMOPERADOR;
        widget.currentRow.CDOPERCONCLUSAO = loggedOperatorInfos.CDOPERADOR;
        widget.currentRow.NRSEQCONTATO    = widget.parent.parent.currentRow.NRSEQCONTATO;
	};

    self.evolucaoNewRow = function(widget)
    {
        
        General.widgetNewRow(widget);
        
        var currentRow = widget.currentRow;
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? widget.currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
        currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        currentRow.NRRELACIONAPARC = "";
        currentRow.IDSENEVOCONT = 'S';
        currentRow.IDTPEVOLCONT = 'P';
        currentRow.IDANEXOEVOLCONT = 'N';
        currentRow.CDFILIAL = "";
        currentRow.IDGERAFATURA = 'NAO';

        
        this.unlockNextTask(widget);
        this.setNewTaskPermission(widget, false);
        this.setOperatorNextTask(currentRow, loggedOperatorInfos);
        
        setLocalVar('PARCEIRO', widget.parent.parent.currentRow.NRPARCNEGOCIO);
        widget.getField('NMPARCINTERLOCUTOR').reload();
    };
    
     this.setOperatorNextTask = function(currentRow, loggedOperatorInfos){
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    };
    
    self.taskScheduleNewRow = function(widget)
    {

        General.widgetNewRow(widget);
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        widget.currentRow.DTPLANFILACONTA = (widget.currentRow.DTPLANFILACONTA) ? widget.currentRow.DTPLANFILACONTA : moment(new Date()).format('DD/MM/YYYY HH:mm');
        widget.currentRow.IDATIVO = 'S';
        widget.currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;

        widget.currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        widget.currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        widget.currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        // widget.currentRow.NRPRIORFILACONT = 2;

        widget.currentRow.NRSEQCLASSIFICATAREFA = "";
        widget.currentRow.DTREALFILACONTA = "";
        widget.currentRow.NMPRINCIPALPARC = '';
        widget.currentRow.DSEMAILTAREFA = '';
        widget.currentRow.DSTELEFONETAREFA = '';

        if(widget.parent.parent.currentRow.NRPARCNEGOCIO)
        {
            widget.getField('NMPRINCIPALPARC').dataSourceFilter[0].value = widget.parent.parent.currentRow.NRPARCNEGOCIO;
            widget.getField('NMPRINCIPALPARC').reload();
        }
    };

	self.defaultEditAuditRow = function(widget)
	{
		Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            if(widget.currentRow.__is_new)
    		{
    			widget.currentRow.NRORG = operator[0].NRORG;
    	        widget.currentRow.NRORGINCLUSAO = operator[0].NRORG;
                widget.currentRow.CDOPERINCLUSAO = operator[0].CDOPERADOR;
                widget.currentRow.DTINCLUSAO = moment(new Date()).format('DD/MM/YYYY HH:mm');
    		}
    		else
    		{
    			widget.currentRow.NRORGULTATU = operator[0].NRORG;
    			widget.currentRow.CDOPERULTATU = operator[0].CDOPERADOR;
                widget.currentRow.DTULTATU = moment(new Date()).format('DD/MM/YYYY HH:mm');
    		}
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
	};

	self.checkRequirements = function(widget)
	{
		if(!widget.isValid())
		{
			ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
			return false;
		}

		return true;
	};

	self.podeEditarRowdoCaso = function(row, widget)
	{
		if(row.NRSEQSITUACAO == 3)
		{
			widget.getAction('EDIT').isVisible = false;
		}
		else
		{
			widget.getAction('EDIT').isVisible = true;
		}
	};

    self.saveConclusaoAndAtuMotivo = function(widget)
    {
        if(self.checkRequirements(widget))
        {   
            var parametroRestEngine = {
                "requestType": "Row",
                "row": widget.currentRow
            };
            
            restEngine.post('/updateMotivo', parametroRestEngine,
                function(success) {
                    
                    self.defaultEditAuditRow(widget);
            
                    return General.widgetSave(widget).then(function(response)
                    {
        
                        if(response.dataset.DADOS && response.dataset.DADOS.NRSEQCONCLUSAO)
                        {
                            widget.currentRow.NRSEQCONCLUSAO = response.dataset.DADOS.NRSEQCONCLUSAO;
                            widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                        }
                        else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
                        {
                            widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                        }
                    });
                    
                }, undefined, 
                function(error) {
                    ScreenService.showMessage("Operação não concluida, Tente Novamente");
                    return;
                }
            ); 
        }
    };

    self.saveEvolucao = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(widget.isValid()){
        
            this.setValuesToInsertNextTask(widget);
            
            this.insertEvolutionNextTask(widget).then(function(responseInsertNextTask){
                
                this.cleanNextTaskFieldValues(widget);
                
                currentRow.NRSEQFILACONTA = (responseInsertNextTask) ? responseInsertNextTask.dataset.DADOS.NRSEQFILACONTA : "";
                
                return widget.saveRow().then(function(response)
                {
                    widget.currentRow.changed = false;
                    widget.currentRow.__is_new = false;
    
                    if(response.dataset.DADOS && response.dataset.DADOS.NRSEQEVOLCONT)
                    {
                        widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                        widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                    }
                    else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
                    {
                        widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                    }
    
                    General.changeWidgetAcessibility(widget.widgets, true);
                    widget.view();
                    
                    if(widget.COMPLETETASK){
                        
                        this.setTaskEndDate(widget);
                            
                    }else{
                        
                        ScreenService.confirmMessage
                        ("Deseja realizar a apropriação da evolução?","question",
                            function()
                            {
                                
                                var childWidget = widget.widgets[0];
                                
                                childWidget.activate();
                                setTimeout(function () {
                                    self.apropriaNewRow(childWidget);
                                }, 300);
                            
                            },
                            function()
                            {
                        });
                        
                    }
                    
                }.bind(this)).catch(function(err) {
                    ScreenService.showMessage(err.data.error);
                });
                 
            }.bind(this)).catch(function(error){
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                
            });
        
        }
    };
    
    this.setValuesToInsertNextTask = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
        
    };
    
	self.saveCaso = function(widget)
	{
        widget.getField('NMOPERCONT').readOnly = true;

        if(widget.currentRow.__is_new){
            delete widget.currentRow.NRSEQCONTATO;
        }
        
		return General.widgetSave(widget).then(function(response)
		{

            if(response.dataset.DADOS && response.dataset.DADOS.NRSEQCONTATO)
            {
                widget.currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
                widget.currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;
                widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
            }
            else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
            {
            	widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
            }
            
		});
	};

    self.saveTask = function(widget)
    {

        self.defaultEditAuditRow(widget);

        widget.currentRow.CDFILIAL = "";
        widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA)? widget.currentRow.NRSEQCLASSIFICATAREFA : null;

        return General.widgetSave(widget).then(function(response)
        {

            if(response.dataset && response.dataset.DADOS[0].NRSEQFILACONTA)
            {
                widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS[0].NRSEQFILACONTA;
            }
        });
        
    };

	self.initTabGeneric = function(widget, field)
    {
        if(widget.parent.parent.currentRow[field])
        {
            widget.dataSourceFilter[0].value = widget.parent.parent.currentRow.NRORG;
            widget.dataSourceFilter[1].value = widget.parent.parent.currentRow[field];
        }

        widget.reload();
    };

	self.ActivateField = function (widget, field, decisiveField)
    {
        field = widget.getField(field);
        decisiveField = widget.currentRow[decisiveField];
        if((decisiveField !== null) && (decisiveField !== '') && (decisiveField !== undefined))
        {
            field.clearValue();
            field.readOnly = false;
            field.reload();
        }
    };
    
    self.initFilterNMoticont = function(widget){
        var currentRow = widget.currentRow;
        
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            
            if(!currentRow.NMSISTEMA){
                Utilities.insertFilter(widget.getField('NMMOTICONT'), "CDOPERADOR", "=", "", 1);  
            }else{
                Utilities.insertFilter(widget.getField('NMMOTICONT'), "CDOPERADOR", "=", operator[0].CDOPERADOR, 1); 
            } 
            widget.getField('NMMOTICONT').reload();
            
            }, function(error)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
            });
    };
    
    self.ActivateFieldMotivo = function (widget, field, decisiveField)
    {   
        
        var currentRow = widget.currentRow;
        
        self.initFilterNMoticont(widget);
        setLocalVar('CDSISTEMA',currentRow.CDSISTEMA);
        self.ActivateField(widget, field, decisiveField); 
                
    };
    
    self.uploadFile = function (widget)
    {
        
        var currentRow = widget.currentRow;
        
        var files = currentRow.DSCAMINHO;
        
        
        if(files && files.length !== 0){
            var rows = [];
            
            files.forEach((function(file, index) {
                rows.push(this.setValuesForCaseFileUpload(widget, index)); 
            }).bind(this));
            
            General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
                this.closeAnexoSwipe(widget);
                widget.parent.parent.reload();
            }.bind(this));
            
        }else{
            
            ScreenService.showMessage("Selecione um arquivo para anexar ao caso.");
            
        }
            
    };
    
    this.setValuesForCaseFileUpload = function(widget, index){
        
        var currentRow = angular.copy(widget.currentRow);
        var caseWidget = widget.parent.parent;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQCONTATO = caseWidget.currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWhithoutExtension(currentRow.DSCAMINHO[index].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[index].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[index].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "CONTATO";
        currentRow.NRORIGEM = caseWidget.currentRow.NRSEQCONTATO;
        
        return currentRow;        
    };
    
    this.getFileExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
            
    };
    
    this.getFileNameWhithoutExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    self.createWidgetDataSource = function(widget)
    {
        var pathDir = getLocalVar('PATHDIR');
        if(pathDir === null || pathDir === undefined)
        {
            restEngine.post('crm#/crm_anexos/returnPathDir',
            {
                "requestType": "Row",
                "row": {}
            }, function(data)
            {
                setLocalVar('PATHDIR', data.dataset.pathDir[0]);
            }, undefined, function(error)
            {
                console.log(error);
            });
        }

        widget.currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        widget.currentRow.NRORG = widget.parent.parent.currentRow.NRORG;

        restEngine.post('crm#/crm_anexos/createFileDataSet',
        {
            "requestType": "Row",
            "row": widget.currentRow
        }, function(success)
        {
            localStorageEngine.remove('/crm_anexos', '').then(function()
            {
                localStorageEngine.save('/crm_anexos', success.dataset.crm_anexos).then(function()
                {
                    var widget = templateManager.container.getWidget('listAnexos');
                    widget.reload();
                });
            });
        },undefined, function(error)
        {
            console.log(error);
        });
    };

    self.downloadFile = function(widget)
    {
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
    };

    self.closeAnexoSwipe = function(widget)
    {
        ScreenService.closeSwipe().then(function(){
            
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
           
        });
    };

    self.openAnexoSwipe = function(widget)
    {
        widget.isVisible = true;
        ScreenService.openSwipe(widget);
    };

    self.apropriaNewRow = function(widget)
    {
        General.widgetNewRow(widget);
        self.defaultEditAuditRow(widget);
        self.controlarCampos(widget);

        widget.currentRow.IDTIPOAPONTAMENTO = "H";
        widget.currentRow.NRSEQEVOLCONT = widget.parent.parent.currentRow.NRSEQEVOLCONT;
    };

    self.controlarCampos = function(widget)
    {
        widget.getField('NRHORASAPONTAMENTO').readOnly = widget.currentRow.IDTIPOAPONTAMENTO === "D";
        widget.getField('DTINIAPONTAMENTO').readOnly = (widget.currentRow.IDTIPOAPONTAMENTO !== "D");
        widget.getField('DTFINAPONTAMENTO').readOnly = (widget.currentRow.IDTIPOAPONTAMENTO !== "D");

        if(widget.currentRow.__is_new)
        {
            widget.currentRow.NRHORASAPONTAMENTO = "000:00";
            widget.currentRow.DTINIAPONTAMENTO = null;
            widget.currentRow.DTFINAPONTAMENTO = null;
        }
    };

    self.saveApropriacao = function(widget)
    {
        if(self.validarApropriacao(widget))
        {
            self.defaultEditAuditRow(widget);

            if(widget.currentRow.IDTIPOAPONTAMENTO == "D")
            {
                var dataini = moment(widget.currentRow.DTINIAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var datafin = moment(widget.currentRow.DTFINAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var minutes = datafin.diff(dataini)/60000;
                var hours = minutes/60;
                minutes = minutes%60;
                widget.currentRow.NRHORASAPONTAMENTO = self.pad(parseInt(hours), 3) + ":" + self.pad(parseInt(minutes), 2);
            }

            widget.currentRow.NRHORASAPONTAMENTO = widget.currentRow.NRHORASAPONTAMENTO.replace(":", "");

            return widget.saveRow().then(function(response)
            {
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;

                if(response.dataset.DADOS && response.dataset.DADOS.NRSEQAPONTAMENTO)
                {
                    widget.currentRow.NRSEQAPONTAMENTO = response.dataset.DADOS.NRSEQAPONTAMENTO;
                    widget.currentRow.NRSEQRELACAPONT = response.dataset.DADOS.NRSEQRELACAPONT;
                    widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                }
                else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
                {
                    widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                }

                Utilities.changeWidgetVisibility(widget.widgets, true);
                widget.view();
                widget.reload();
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };

    self.validarApropriacao = function(widget)
    {
        if(self.checkRequirements(widget))
        {
            if(widget.currentRow.IDTIPOAPONTAMENTO === "D")
            {
                var dataini = moment(widget.currentRow.DTINIAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var datafin = moment(widget.currentRow.DTFINAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var diffMinutos = datafin.diff(dataini);

                if(diffMinutos <= 0)
                {
                    ScreenService.showMessage('Data inicial deve ser menor/igual à data final.');
                    return false;
                }
                else if((widget.currentRow.DTINIAPONTAMENTO === null || widget.currentRow.DTFINAPONTAMENTO === null))
                {
                    ScreenService.showMessage('Ambas as datas devem ser informadas.');
                    return false;
                }
            }

            return true;
        }

        return false;
    };

    self.pad = function (n, width, z)
    {
        z = z || '0';
        n = n + '';
        return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
    };

    self.controlHorasApont = function(widget)
    {
        var tempo = widget.currentRow.NRHORASAPONTAMENTO.split(":");
        var hora = parseInt(tempo[0]);
        var minutes = parseInt(tempo[1]);

        if(minutes >= 60)
        {
            minutes -= 60;
            hora ++;
            widget.currentRow.NRHORASAPONTAMENTO = self.pad(hora, 3)+":"+self.pad(minutes, 2);
        }
    };
    
    this.setSituationFieldFilter = function(field){
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORG");
        var nrorgPadraoFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORGPADRAO");
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        fieldFilter[nrorgPadraoFilterIndex].value = getLocalVar("CRM_NRORGPADRAO");
        
        CRM_Utilities.setDefaultOrgFilterAndOperatorOrgFilter(field);
        
        field.reload();
            
    };
    
    /**
     * Função para checar a permissão para gerar
     * uma nova tarefa a partir de uma nova evolução.
     * 
     * @param {object} widget widget ativa, no modo
     * edit, onde está sendo cadastrado a evolução.
    */
    this.checkNewTaskPermissionByEvolutionResult = function(widget){
        
        var currentRow = widget.currentRow;
        
        
        if(currentRow.IDGERPROXATIV && currentRow.IDGERPROXATIV === "S" && !currentRow.NEXTTASKBLOCKED){
            
            this.setNewTaskPermission(widget, true);
            
        }else{
            
            this.setNewTaskPermission(widget, false);
            
        }
            
    };
        
    /**
     * Função para resetar as informações
     * de criação de uma nova tarefa(a partir de uma
     * evolução).
     * 
     * @param {object} widget widget de evolução, que terá
     * as informações resetadas.
    */
    this.resetNewTaskInfos = function(widget){
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.DTPLANFILACONTA = "";
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.DSFILACONTATO = "Retornar contato";
            
    };
    
    /**
     * Função para inserir um tarefa vinculada
     * a uma evolução.
     * 
     * @param {object} widget widget de evolução
     * com as informações da tarefa a ser inserida
     * em sua currentRow.
    */
    this.insertEvolutionNextTask = function(widget){
        
        var currentRow = widget.currentRow;
        var deferred = ZHPromise.defer();
        
        if(currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED){
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/insertEvolutionNextTask/caso', paramsRestEngine,
                function(success){
                    
                },undefined,
                function(error){
                    
                },undefined,undefined
            );
            
        }else{
            
            deferred.resolve();
            
        }
        
        return deferred;
        
    };
    
    /**
     * Função para limpar os valores dos campos
     * para gerar uma nova tarefa através de uma
     * evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.cleanNextTaskFieldValues = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(!currentRow.DTPLANFILACONTA){
            
            currentRow.DTPLANFILACONTA = "";
            currentRow.DSFILACONTATO = "";
            currentRow.NMOPERADORREAL = "";
            
        }
        
    };
    
    /**
     * Função para editar uma evolução.
     * 
     * @param {object} widget widget ativa, no
     * modo de visualização, com as informações
     * da evolução a ser editada.
    */
    this.editEvolution = function(widget){
        
        General.widgetEdit(widget);
        
        this.checkPermissionToCreateNewTaskInEvolutionEdition(widget);
            
    };
    
    /**
     * Função para verificar a permissão para inserir
     * uma nova tarefa na edição da evolução em caso.
     * 
     * @param {object} widget widget ativa, no modo de
     * edição, com as informações da evolução em edição.
    */
    this.checkPermissionToCreateNewTaskInEvolutionEdition = function(widget){
        
        var currentRow = widget.currentRow;
        
        
        if(currentRow.DTPLANFILACONTA){
            
            this.setTaskFieldLock(widget, true);
            
            currentRow.NEXTTASKBLOCKED = true;
            
        }else{
            
            this.unlockNextTask(widget);
            this.checkNewTaskPermissionByEvolutionResult(widget);
            this.resetNewTaskInfos(widget);
        }
        
    };
    
    /**
     * Função para setar a permissão de criar uma nova
     * tarefa a partir do resultado da evolução.
     * 
     * @param {object} widget widget ativa, no modo edit,
     * onde está sendo cadastrado a evolução.
     * 
     * @param {boolean} isAllowed permissão booleana do
     * cadastro da tarefa.
    */
    this.setNewTaskPermission = function(widget, isAllowed){
        
        if(isAllowed){
            
            this.setTaskFieldLock(widget, false);
            
            widget.currentRow.DTPLANFILACONTA = "";
            
        }else{
            
            this.setTaskFieldLock(widget, true);
            
        }
            
    };
    
    /**
     * Função para definir o bloqueio dos campos
     * de agenda de tarefa na widget de evolução.
     * 
     * @param {object} widget widget de evolução,
     * onde estão os campos para criar um nova
     * tarefa.
     * 
     * @param {boolean} isLocked estado dos campos.
    */
    this.setTaskFieldLock = function(widget, isLocked){
        
        var nextTaskDate = widget.getField("DTPLANFILACONTA");
        var taskOperator = widget.getField("NMOPERADORREAL");
        var taskDescription = widget.getField("DSFILACONTATO");
        
        nextTaskDate.readOnly = isLocked;
        taskOperator.readOnly = isLocked;
        taskDescription.readOnly = isLocked;
            
    };
    
    /**
     * Função para liberar o cadastro de uma
     * nova tarefa a partir de um evolução,
     * excluindo o parâmetro de bloqueio.
     * 
     * @param {object} widget widget de evolução.
    */
    this.unlockNextTask = function(widget){
        
        if(widget.currentRow.NEXTTASKBLOCKED){
        
            delete widget.currentRow.NEXTTASKBLOCKED;
            
        }
        
    }; 
    
    /**
     * Função para deletar uma tarefa,
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, mostrando a tarefa a ser deletada.
    */
    this.deleteTask = function(widget){
        
        General.deleteCrud(widget).then(function(){
                    
        }).catch(function(){
            
            ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question',
            
                function (success) {
        		    
                    this.deactivateCaseTask(widget).then(function(){
    		        
                        ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                            		        
        		        ScreenService.closeSwipe().then(function(){
        		            
        		            widget.reload();
        		              
        		        });
    		              
    		        }).catch(function(error){
    		            
    		            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));  
    		            
    		        });
        		    
        		}.bind(this));
                
        }.bind(this));
          
    };
    
    /**
     * Função para desativar uma tarefa.
     * 
     * @param {object} widget widget de agenda de
     * tarefas, no modo de vizualisaçãom, com as
     * informações da tarefa a ser excluida.
    */
    this.deactivateCaseTask = function(widget){
        
        var currentRow = widget.currentRow;
        
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/deactivateCaseTask', paramsRestEngine,
                function(success){
                    
                },undefined,
                function(error){
                    
                },undefined,undefined
            );
            
    };
    
    /**
     * Função para possibilitar o cadastro de
     * uma evolução referente a tarefa em caso,
     * indicando a conclusão da tarefa.
     * 
     * @param {object} widget widget ativa, no modo
     * view, referente a tarefa em caso.
    */
    this.completeTask = function(widget){
        
        var evolutionWidget = templateManager.container.getWidget("evolucao");
        
        evolutionWidget.COMPLETETASK = true;
        evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
        
        ScreenService.closeSwipe().then(function(){
            
            this.activateWidget(evolutionWidget).then(function(){
                
                setTimeout(function(){    
                    this.evolucaoNewRow(evolutionWidget);
                }.bind(this), 500);
                
            }.bind(this));
            
        }.bind(this));
            
    };
    
    /**
     * Função para ativar uma widget
     * 
     * @param {object} widget widget que será
     * ativada.
     * 
     * @return {object} deferred 'promise' indicando
     * a conclusão da tarefa da função.
    */
    this.activateWidget = function(widget){
        
        var deferred = ZHPromise.defer();
        
        widget.activate();
        deferred.resolve();
        
        return deferred;
    };
    
    /**
     * Função para pegar as informações da tarefa
     * na widget de evolução e setar a data de
     * conclusão da tarefa no registro da própria
     * tarefa.
     * 
     * @param {object} widget widget ativa que contém
     * as informações da tarefa que será concluida.
    */
    this.setTaskEndDate = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(widget.COMPLETETASK){
            
            currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/setTaskEndDate/caso', paramsRestEngine,
                function(success){
                    
                    ScreenService.showMessage("Tarefa Concluída com sucesso.");
                    this.deleteTaskInfosInEvolutionWidget(widget);
                     
                }.bind(this),undefined,
                function(error){
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                    
                },undefined,undefined
            );
        }

    };
    
    /**
     * Função para deletar as informações da
     * tarefa a ser concluída da widget de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.deleteTaskInfosInEvolutionWidget = function(widget){
        
        delete widget.COMPLETETASK;
        delete widget.NRSEQFILACONTA;
        
    };
    
    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAnnexSwipe = function(){
        
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        
        fileUploadWidget.isVisible = true;
        ScreenService.openSwipe(fileUploadWidget);
            
    };
    
    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
    */
    this.uploadEvolutionFiles = function(widget){
        
        var files = widget.currentRow.DSCAMINHO;
        
        var rows = [];
        
        files.forEach(function(file, fileIndex){
            
            rows.push(this.setValuesForEvolutionFileUpload(widget, fileIndex));
            
        }.bind(this));
        
        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
            
                this.closeAnnexSwipe(widget);
                widget.parent.parent.reload();
                
        }.bind(this));
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForEvolutionFileUpload = function(widget, fileIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var evolutionWidget = widget.parent.parent;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAnnexSwipe = function(widget){
        ScreenService.closeSwipe().then(function(){
            
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
           
        });
    };
    
    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget){
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
            
    };
    
    this.validateCaseCustomCode = function(widget){
            
        var currentRow = widget.currentRow;
        
        if(currentRow.CDCASO){
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
                
            return restEngine.post('/validadeCaseCustomCode', paramsRestEngine,
                function(success){
                    
                    if(success.dataset.DADOS.length > 0){
                        
                        currentRow.CDCASO = "";
                        ScreenService.showMessage(Messages.CODIGO_PERSONALIZADO_EXISTENTE);
                            
                    }
                    
                }.bind(this),undefined,
                function(error){
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                    
                },undefined,undefined
            );
        
        }
            
    };
}

Configuration(function(ContextRegister)
{
    ContextRegister.register('crm20000_Caso_Controller', crm20000_Caso_Controller);
});