var engine = function (templateManager, eventAggregator, ScreenService, localStorageEngine, ZHPromise, LibLoginController, LibUtilities, ZhuAclController, General, ApplicationContext) {

    const BEFORE_PROJECT_STARTUP_EVENT = "beforeProjectStartup";

    eventAggregator.subscribe(BEFORE_PROJECT_STARTUP_EVENT, function () {
        var origin = window.location.hash;
        if(origin.indexOf('crm_profile') === -1){
            authenticateUser();
        }
    });

    var setParameters = function(session) {
        
        var operatorName = session.user ? session.user.nmoperador : session.nmoperador;
        var orgName = session.user ? session.user.nmorg : session.nmorg;
        
        ScreenService.buildUserData(operatorName, [orgName], function(){
            ScreenService.openWindow('product#crm_profile');
        }, window.defaultUserImageUrl);
        ScreenService.setHeaderInfo(orgName);
    };

    var setLocalVars = function(user) {
        
        localStorageEngine.setLocalVar('CRM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('CRM_NRORG', user.nrorg);
        localStorageEngine.setLocalVar('CRM_NRORGTRAB', user.nrorgtrab);
        localStorageEngine.setLocalVar('CRM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('CRM_NMOPERADOR', user.nmoperador);
        localStorageEngine.setLocalVar('CRM_DSEMAILOPER', user.dsemailoper);
        localStorageEngine.setLocalVar('CRM_NRORGPADRAO', 0);
        localStorageEngine.setLocalVar('PROJECT_ID', window.projectId);
        
    };
    
    eventAggregator.subscribe('authSuccess', function(session) {
        
        var user = session.user;
        var cdoperador = user.cdoperador;
        var perfilDeAcesso = user.perfilDeAcesso;
        
    //    setLocalVars(session.user);
       // setParameters(session);
        
        
        setLocalVars(user);
        setUserID(user);
        setParameters(user);
        setGeneralParameters(user.nrorg);
        
        
        //Zeedhi Access Control
        localStorageEngine.setLocalVar("userId", cdoperador);
        localStorageEngine.setLocalVar("accessProfiles", perfilDeAcesso);
        //localStorageEngine.setLocalVar("productIdLoginUrl", ConfigLogin.loginProductId);
        
    });
    
   /*var validateLoginResponse = function(response) {
        
        var responseold = response;
        response = LibUtilities.changeLoginResponseToOldParams(response);
        
        if(response && response.cdoperador) {
            
            eventAggregator.publish("loginSuccess", responseold);
            //loadAcl(response); // era necessário somente na versão até 1.7.1 da lib teknisa

            eventAggregator.publish("authSuccess", { user: response });
        }
    };*/
    
    /**** inicio  do que foi colocado  como teste *****/
    
    var validateLoginResponse = function(response, loginDefer) {
        var responseold = response;
        response = LibUtilities.changeLoginResponseToOldParams(response);
        if(response && response.cdoperador) {
            
            eventAggregator.publish("loginSuccess", responseold);
            eventAggregator.publish("authSuccess", { user: response });
            
            eventAggregator.publish("setParamsProduct", { user: response });
            loginDefer.resolve();
            
            /*if (!window.location.hash || window.location.hash.endsWith("product#dashboard") || !localStorageEngine.getLocalVar("CDOPERADOR") || localStorageEngine.getLocalVar("CDOPERADOR") != response.cdoperador) {
                
                eventAggregator.publish("authSuccess", { user: response });
            }
            else {
                setParameters(response);
            }*/
        }
    };
    
    
    var authenticateUser = function() {
        if(typeof memoryStorage !== 'undefined') {
            localStorageEngine.getLocalVar = memoryStorage.getLocalVar;
            localStorageEngine.setLocalVar = memoryStorage.setLocalVar;
            setLocalVar = memoryStorage.setLocalVar;
            getLocalVar = memoryStorage.getLocalVar;
        }
        
        var loginDefer = ZHPromise.defer();
        localStorageEngine.setLocalVar('loginPromise', loginDefer.promise);

        LibLoginController.authenticate().then(function(response) {
            validateLoginResponse(response, loginDefer);
        }).catch(function (error) {
				if (error.data) {
					ScreenService.showMessage(error.data.error);
				} else {
					ScreenService.showMessage(JSON.stringify(error));
				}
			});
    };
    
    
    
     var setUserID = function(user) {
        //ZhPreferences.setUserID(user.cdoperador);
        if(ApplicationContext.ZhPreferences) {
            ApplicationContext.ZhPreferences.setUserID(user.cdoperador);
        } else {
            ApplicationContext.zhCustomizationsService.registerUser(user.cdoperador);
        }
    };
    
    
    function getTableByName(tableName, filter) {
        if (!filter) {
            filter = [];
        }
        return General.callRestEngine("product#/crud/" + tableName, "FilterData", filter).then(function (response) {
            var result = [];
            if (response.dataset[tableName])
                result = response.dataset[tableName];
            return result;
        });
    }
    
    function getParamgeral(filtro) {
        return getTableByName("paramgeral", filtro).then(function(response) {
            var paramgeral = null;
            if (response.length)
                paramgeral = response[0];
            return paramgeral;
        });
    }
    
    function setGeneralParameters(nrorg) {
        var filtro = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": nrorg
            }
        ];
        return getParamgeral(filtro).then(function (paramgeral) {
            if (paramgeral) {
                localStorageEngine.setLocalVar('CAD_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTCCTB', replaceMask(paramgeral.CDPICTCCTB, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
                localStorageEngine.setLocalVar('CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
            } else {
                ScreenService.showMessage("Parâmetros gerais não configurados", "E");
            }
        });
    }
    
    
    /***** fim do que foi colocado como teste *****/
    
    var loadAcl = function (response) {
        ZhuAclController.setUserRules(response.perfilDeAcesso, window.projectId, response.cdoperador, response.nrorg, {defaultRule: "A"});
    };
    
    this.confirmLogoutLib = function(){        
        ScreenService.confirmMessage("Deseja realmente sair do sistema?", "question", function(){
            LibLoginController.logout();
        }, null);
    };
    
    var replaceMask = function(value, regex) {
        return (value || '').toString().replace(regex, '*');
    };
    
    var regularExpressions = {
        LETTERS: /((a|A))/g,
        LETTERS_AND_NUMBERS: /((a|A|9))/g
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('engine', engine);
});